<template>
  <div class="sect-header">
    
    <section class="item-form">
      <h1> <span class="color-prime">envía</span> tu consulta</h1>
      <hr class="head-hr">
      <p class="slogan">
        Pregunta al doctor y/o el grupo de especialistas nesites.
      </p>
      <p class="slogan">
        Cuando tengas una respuesta te avisaremos en tu correo electrónico
      </p>

      <form @submit="checkForm">
        <ul>
          <li>
            <label class="lab-width">Doctor:</label>  
            <input type="text" v-model="email_doc" :placeholder="$route.params.emaildoc">
          </li>

          <li>
            <label class="lab-width">Grupo de especialistas:</label>  
            <select type="text" v-model="specialtyGroup"  >
              <option value='' selected>Grupo de especialistas</option>
              <option value="Clínica">Clínica</option>
              <option value="Quirúrgicas">Quirúrgicas</option>
              <option value="Médico quirúrgicas">Médico-quirúrgicas</option>
              <option value="Laboratorio o diagnósticas">Laboratorio o diagnósticas</option>
            </select>
          </li>

          <li>
            <label class="lab-width">Asunto:</label>
            <input type="text" v-model="subject" placeholder="Asunto">
          </li>

          <li>
            <label class="lab-width align-middle" >Consulta:</label>
            <textarea v-model="message" placeholder="Escriba su consulta"></textarea>
          </li>

          <li>
            <label class="lab-width">Adjuntar archivo:</label>
            <input type="text" v-model="attached" placeholder="archivo">
          </li>

          <li>

            <div>
              <!--  inicio validación de errores -->
                  <div v-if="errors.length" class="warning-msg">
                    <i class="fa fa-warning"></i> <b>Parece que te faltan por cubrir los siguientes datos:</b>
                    <br><br>
                      <ul>
                        <li>{{ errorBack }}</li>
                        <li v-for="error in errors" :key="error.index">{{ error }}</li>
                      </ul>
                  </div>
                <!-- fin validación de errores -->
                <button  class="button-prime button-item">Enviar</button>
            </div>
          </li>
        </ul>
      </form>
    </section>
    <!-- pack statistics -->
    <section class="pack">
      <ul>
        <li>
          <img src="../assets/images/icons/ico-inquire.png" class="img-inquiry">
        </li>
        <li>
          <h3>
            Pack
            {{numMessagesSendByPack.packType}}
          </h3>
        </li>
        <!-- menaje sobre tu pack -->
        <li v-if="numMessagesSendByPack.status !== 0">
          Has enviado {{ numMessagesSendByPack.totalnumbermessages }} consutas 
          <br>
          Todavía te quedan {{numMessagesSendByPack.warningPack}} 
          <br>
          <!-- {{ moment().add(1, 'days').calendar() }} -->
           Hasta el {{getDateFromToday(numMessagesSendByPack.numberdays)}}        
        </li>

        <!-- mensaje pack terminado   -->
        <li v-else >
           {{numMessagesSendByPack.warningPack}}
        </li>
      </ul>
    </section>

  </div>
</template>

<script>
import axios from 'axios';
import Swal from 'sweetalert2';

import moment from 'moment';

import { getAuthToken } from '../../../backend/utils/utils'
import { getID } from '../../../backend/utils/utils'
import { getIsPack } from '../../../backend/utils/utils'




export default {
  name:'sendinquirevi',
  // inicio data
  data(){
    return{

    
      email_doc: '',
      specialtyGroup: '',
      subject: null,
      message: null,
      attached: null,

      // para la validacion
      errors:[],

      // Si sendInquire es false los datos no se envian
      sendInquire: false,

      //errores que llegande back
      errorBack:null,

      //Numero de mensajes enviados en los ultimos x días
      numMessagesSendByPack: {},

      alert:{
        alert_title_SwalEmail: 'Consulta enviada correctamente!!!',
        alert_text_SwalEmail: 'Tu doctor está avisado, te enviaremos a tu cuenta en cuanto recibas',
      }

      
    };
  },
  //FIN DATA
   methods:{
     
    checkForm:function(e) {
      // si no viene el mail del doctor por params le damos el valor que escribimos en el input
      // si no le damos el valor que nos viene por params
       if(!this.$route.params.emaildoc){
         this.email_doc
       }else{
         this.email_doc = this.$route.params.emaildoc
       }
       if(!this.$route.params.emaildoc && !this.email_doc ){
         this.email_doc = ''
       }
        // console.log('this.email_doc sendinquiry.vue-->',this.email_doc)

      if((this.email_doc || this.specialtyGroup != '') && this.subject && this.message) {

        this.sendInquire = true;
        this.NewInquiry()

        return true
        };

      this.errors = [];

      if(!this.email_doc && !this.specialtyGroup ) this.errors.push("Es necesario indicar a que doctor o grupo de especialistas quieres enviar la consulta");
      if(!this.subject) this.errors.push("Escribe el asunto");
      if(!this.message) this.errors.push("Te falta el mensaje");

      if(this.email_doc) this.errors.push("")
            if(!this.subject) this.errors.push("Escribe el asunto");

      if(!this.message) this.errors.push("");
      
      this.sendInquire = false; // no se envia al backend

      e.preventDefault();
    },
    validEmail: function (email_doc) {
      var re = /^(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
      return re.test(email_doc);
    },

    NumberMessagesByPack(){
      
      var self = this;

      axios.get(`http://localhost:3050/datos?id=${getID()}&typePack=${getIsPack()}`)   
      
      .then( function(response) {

        console.log('respuesta-->',response.data)
        self.numMessagesSendByPack = response.data

      })
      .catch( function (error) {
        console.log(error)
      } )
    },



     // modificar fecha con moment
     getDateFromToday: function (date) {
                   return moment().add(date, 'days').calendar();
            //  return moment(date, 'YYYY-MM-DD').format('DD/MM/YYYY');
         },




    NewInquiry(){
            
            if(this.sendInquire === true){ 
                var self = this;

                axios.post('http://localhost:3050/send',{
                  

                    email_doc: self.email_doc,
                    specialtyGroup: self.specialtyGroup,
                    subject: self.subject,
                    message: self.message, 
                    attached: self.attached,
                    

                },{
                    headers:{
                        Authorization:  getAuthToken()
                    },
                })
                .then( function(response){

                    // Recibimos el posible error de back y lo pasamos errorBack en data()
                    self.errorBack = response.data.message;

                    console.log(response)
                    console.log(response.data.code)

                    // si está todo correcto limpiamos datos
                    // y lanzamos modal
                    if(response.data.code == 200){
                      //modal sweetalert
                      Swal.fire({
                          title: self.alert.alert_title_SwalEmail,
                          text: self.alert.alert_text_SwalEmail,
                          
                          // button: "Cerrar", // Text on button
                          icon: "success", //built in icons: success, warning, error, info
                          timer: 5000 //timeOut for auto-close
                      })

                    
                      // poner ocultar campos
                      self.role = '',

                      //vaciar los campos
                      self.email_doc = ''
                      self.specialtyGroup = ''
                      self.subject = ''
                      self.message = '', 
                      self.attached = '', 

                      self.$route.params.emaildoc = null
                      
                      // location.reload() // recargar la pagina para quitar error

                    }
                      
                     
                })
                .catch( function(error){
                    console.log(error)
                })
                // una vez enviado el mensaje volvemos a poner la variable en false
                this.creatingClient = false;

                
            }else{
                console.log('Yo no debería estar aquí')
            }
        }
  },

  created() {
    this.NumberMessagesByPack()
  }
// FIN METHODS
  

}
</script>

<style scoped>

/* container */

h1 {
  padding-bottom: 1rem;
}

.sect-header {
  height: 90vh;
  display: flex;
  flex-direction: row-reverse;
  align-items: center;  
  padding: 0 5rem;
  height: auto;
  overflow: hidden;
}

.item-form {
    flex: 2;
}

/* label */
.lab-width {
  display: inline-block;
  width: var(--spacer-6);
  padding: 0.5rem 0;
  margin: 0.5rem 0;
}

/* middle align */
ul > li {
  display: flex;
}

/* estatistic pack */

.pack {
  align-self: stretch;
  flex: 1;
}
.pack > ul {
  width: 200px;
  overflow: visible;
  border: 8px solid var(--color-general-whitesmoke);
  padding: 1rem;
}

/* img */
.img-inquiry{
  height: 10rem;
  margin-bottom: 2rem;
} 

/* alineado boton */
.button-item {
  margin: 1rem 0 1rem 105px; 
  padding-left: 2rem;
  padding-right: 2rem;

 }
</style>